qin
2024-09-28 e358beb08f5be49703009b64f058ecfbcfeefbd9
HStation.RevitDev/RevitDataExport/Utility/CacheUtil.cs
@@ -1,9 +1,14 @@
using Autodesk.Revit.DB;
using HStation.RevitDev.Model.ModelEnum;
using HStation.RevitDev.RevitDataExport.Common;
using HStation.RevitDev.RevitDataExport.Entity;
using ICSharpCode.SharpZipLib.Zip;
using System.Collections.Generic;
using System;
using System.IO;
using System.Linq;
using System.Windows.Forms;
using Autodesk.Revit.UI;
namespace HStation.RevitDev.RevitDataExport.Utility
{
@@ -21,7 +26,7 @@
            ConfigRecord record = records.ConfigRecords.Where(x => x.FilePath == filePath)?.FirstOrDefault();
            if (record != null)
            {
                GlobalResource.RevitModels = record.Record;
                GlobalResource.RevitModels.Add(new Tuple<string, Dictionary<RevitType, List<string>>>(doc.Title, record.Record));
            }
        }
@@ -47,8 +52,13 @@
            var record = new ConfigRecord
            {
                FilePath = GlobalResource.LastFilePath,
                Record = GlobalResource.RevitModels
                Record = GlobalResource.RevitModels.Find(x => x.Item1 == doc.Title)?.Item2
            };
            if (!File.Exists(GlobalResource.RecordFilePath))
            {
                File.Create(GlobalResource.RecordFilePath);
            }
            var cache = File.ReadAllText(GlobalResource.RecordFilePath);
            Records records = new Records();
            if (!string.IsNullOrEmpty(cache))
@@ -62,11 +72,106 @@
            }
            else
            {
                configRecord = record;
                configRecord.Record = record.Record;
            }
            var config = Newtonsoft.Json.JsonConvert.SerializeObject(records);
            File.WriteAllText(GlobalResource.RecordFilePath, config);
        }
        public static bool ExportZipFile(Document _doc, out string err)
        {
            FolderBrowserDialog dialog = new FolderBrowserDialog();
            err = "";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                var tempDir = Path.Combine(Path.GetDirectoryName(GlobalResource.BinDirectory), "temp"); //"d:\\temp";
                if (!Directory.Exists(tempDir))
                    Directory.CreateDirectory(tempDir);
                var structFile = tempDir + "\\struct.json";
                var modelFile = tempDir + "\\model.rvt";
                var settingFile = tempDir + "\\setting.json";
                var otherFile = tempDir + "\\struct_others.json";
                try
                {
                    var zipFilePath = dialog.SelectedPath + "\\model.ywrvt";
                    if (File.Exists(structFile)) File.Delete(structFile);
                    if (File.Exists(modelFile)) File.Delete(modelFile);
                    if (!File.Exists(settingFile)) File.Create(settingFile).Close();
                    if (!File.Exists(otherFile)) File.Create(otherFile).Close();
                    File.Copy(_doc.PathName, modelFile);
                    File.Copy(GlobalResource.ExportFilePath, structFile);
                    var notContains = new List<string>() { "管道附件", "管道", "管件 ", "管道附件", "管道系统" };
                    var c3 = new Autodesk.Revit.DB.FilteredElementCollector(_doc).WhereElementIsNotElementType();//.WhereElementIsElementType();
                    var c4 = new Autodesk.Revit.DB.FilteredElementCollector(_doc).WhereElementIsElementType();
                    c3.Concat(c4);
                    var r = c3.Where(c => c.Category != null && !notContains.Any(c.Category.Name.Contains)).Select(c => new { ID = c.Id.ToString(), Name = c.Name, CategoryName = c.Category.Name, CategoryID = c.Category.Id.ToString() }).Distinct().ToList();
                    var t = JsonHelper.ToJson(r);
                    File.WriteAllText(otherFile, t);
                    var setting = new SettingsViewModel() { Version = "1" };
                    File.WriteAllText(settingFile, JsonHelper.ToJson(setting));
                    var files = new string[] { structFile, modelFile, settingFile, otherFile };
                    ZipFiles(files, zipFilePath);
                    File.Delete(structFile);
                    File.Delete(otherFile);
                    File.Delete(modelFile);
                    File.Delete(settingFile);
                    File.Delete(otherFile);
                    return true;
                }
                catch (Exception ex)
                {
                    File.Delete(structFile);
                    File.Delete(otherFile);
                    File.Delete(modelFile);
                    File.Delete(settingFile);
                    File.Delete(otherFile);
                    err = JsonHelper.ToJson(ex);
                    return false;
                }
            }
            else return false;
        }
        private static void ZipFiles(string[] files, string zipFilePath)
        {
            using (var zipOutputStream = new ZipOutputStream(File.Create(zipFilePath)))
            {
                zipOutputStream.SetLevel(9); // 设置压缩级别
                foreach (var file in files)
                {
                    var entry = new ZipEntry(Path.GetFileName(file))
                    {
                        DateTime = DateTime.Now,
                        Size = File.ReadAllBytes(file).Length
                    };
                    zipOutputStream.PutNextEntry(entry);
                    using (var fileStream = File.OpenRead(file))
                    {
                        int sourceBytes;
                        byte[] buffer = new byte[4096];
                        while ((sourceBytes = fileStream.Read(buffer, 0, buffer.Length)) > 0)
                        {
                            zipOutputStream.Write(buffer, 0, sourceBytes);
                        }
                    }
                }
                zipOutputStream.Finish();
                zipOutputStream.Close();
            }
        }
        public static void HideOrShowModels(Document document)
@@ -78,19 +183,58 @@
            {
                return;
            }
            GlobalResource.HideMode = !GlobalResource.HideMode;
            using (Transaction trans = new Transaction(document, "hide elements"))
            try
            {
                trans.Start();
                if (GlobalResource.HideMode)
                GlobalResource.HideMode = !GlobalResource.HideMode;
                using (Transaction trans = new Transaction(document, "hide elements"))
                {
                    document.ActiveView.HideElements(ids);
                    trans.Start();
                    if (GlobalResource.HideMode)
                    {
                        document.ActiveView.HideElements(ids);
                    }
                    else
                    {
                        document.ActiveView.UnhideElements(ids);
                    }
                    trans.Commit();
                }
                else
            }
            catch (Exception ex)
            {
                TaskDialog.Show("错误", "显隐失败,可能存在不能设置隐藏的构件!");
            }
        }
        public static void HideOrShowOtherModels(Document document)
        {
            if (document == null) { return; }
            var ids = GlobalResource.RevitModels.GetOtherIds()?.Select(x => new ElementId(int.Parse(x))).ToList();
            if (ids.Count == 0)
            {
                return;
            }
            try
            {
                GlobalResource.IsOtherHidden = !GlobalResource.IsOtherHidden;
                using (Transaction trans = new Transaction(document, "hide other elements"))
                {
                    document.ActiveView.UnhideElements(ids);
                    trans.Start();
                    if (GlobalResource.IsOtherHidden)
                    {
                        document.ActiveView.HideElements(ids);
                    }
                    else
                    {
                        document.ActiveView.UnhideElements(ids);
                    }
                    trans.Commit();
                }
                trans.Commit();
            }
            catch (Exception ex)
            {
                TaskDialog.Show("错误", "显隐失败,可能存在不能设置隐藏的构件!");
            }
        }
    }